# swagger-client
Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.2
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com//.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com//.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_key
swagger_client.configuration.api_key['key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# swagger_client.configuration.api_key_prefix['key'] = 'Bearer'
# create an instance of the API class
api_instance = swagger_client.CustomerApi()
companyid = 'companyid_example' # str | Company ID
firstname = 'firstname_example' # str | Customer First Name
lastname = 'lastname_example' # str | Customer Last Name
sendtype = '1' # str | Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (default to 1)
email = 'email_example' # str | Customer Email (optional)
mobile = 'mobile_example' # str | Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
address = 'address_example' # str | Customer Postal Address (optional)
zipcode = 'zipcode_example' # str | Customer Zipcode (optional)
city = 'city_example' # str | Customer City (optional)
state = 'state_example' # str | Customer State / Province / Region (optional)
country = 'country_example' # str | Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
language = 'language_example' # str | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
notes = 'notes_example' # str | Additional Customer Notes (optional)

try:
    # Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
    api_response = api_instance.create_customer_automatic(companyid, firstname, lastname, sendtype, email=email, mobile=mobile, address=address, zipcode=zipcode, city=city, state=state, country=country, language=language, notes=notes)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CustomerApi->create_customer_automatic: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://reputationcrm.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CustomerApi* | [**create_customer_automatic**](docs/CustomerApi.md#create_customer_automatic) | **POST** /createCustomerAutomatic | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
*CustomerApi* | [**create_customer_automatic_with_delay_review_request**](docs/CustomerApi.md#create_customer_automatic_with_delay_review_request) | **POST** /createCustomerAutomaticWithDelayReviewRequest | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
*CustomerApi* | [**create_customer_immediate_first_review_request**](docs/CustomerApi.md#create_customer_immediate_first_review_request) | **POST** /createCustomerImmediateFirstReviewRequest | Create a Customer AND Feedback / Review Requests
*CustomerApi* | [**create_customer_manual_schedule_one_review_request**](docs/CustomerApi.md#create_customer_manual_schedule_one_review_request) | **POST** /createCustomerManualScheduleOneReviewRequest | Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
*CustomerApi* | [**delete_customer**](docs/CustomerApi.md#delete_customer) | **DELETE** /deleteCustomer | Delete ONE Customer record
*CustomerApi* | [**get_all_customers_bycompany_id**](docs/CustomerApi.md#get_all_customers_bycompany_id) | **GET** /getAllCustomersBycompanyId | Get Information on ALL Customers of a Company / Location / Feedback Page
*CustomerApi* | [**get_customers_who_have_not_yet_submitted_review**](docs/CustomerApi.md#get_customers_who_have_not_yet_submitted_review) | **GET** /getCustomersWhoHaveNotYetSubmittedReview | Get a list of Customers who have not yet submitted their Review / Feedback
*CustomerApi* | [**get_single_customer**](docs/CustomerApi.md#get_single_customer) | **GET** /getSingleCustomer | Get Information of ONE Customer
*CustomerApi* | [**update_customer**](docs/CustomerApi.md#update_customer) | **PUT** /updateCustomer | Update the record of ONE Customer
*EmailSMSStatsApi* | [**get_email_sms_sent_count**](docs/EmailSMSStatsApi.md#get_email_sms_sent_count) | **GET** /getEmailSmsSentCount | Email / SMS sent
*EmailSMSStatsApi* | [**get_email_sms_sent_limit**](docs/EmailSMSStatsApi.md#get_email_sms_sent_limit) | **GET** /getEmailSmsSentLimit | Email / SMS Limit
*QueueApi* | [**delete_queue_by_customer_id**](docs/QueueApi.md#delete_queue_by_customer_id) | **DELETE** /deleteQueueByCustomerId | Delete requests of a customer
*QueueApi* | [**delete_queue_bycompany_id**](docs/QueueApi.md#delete_queue_bycompany_id) | **DELETE** /deleteQueueBycompanyId | Delete requests of a company
*QueueApi* | [**get_queue_bycompany_id**](docs/QueueApi.md#get_queue_bycompany_id) | **GET** /getQueueBycompanyId | Get a customerâ€™s queue
*QueueApi* | [**get_single_customer_queue**](docs/QueueApi.md#get_single_customer_queue) | **GET** /getQueueByCustomerId | Get a customerâ€™s queue
*RescheduleApi* | [**reschedule_customer_automatic**](docs/RescheduleApi.md#reschedule_customer_automatic) | **POST** /rescheduleCustomerAutomatic | Reschedule Customer (Automatic)
*RescheduleApi* | [**reschedule_customer_immediate**](docs/RescheduleApi.md#reschedule_customer_immediate) | **POST** /rescheduleCustomerImmediate | Reschedule Customer (Send right away)
*RescheduleApi* | [**reschedule_manual_one_review_request**](docs/RescheduleApi.md#reschedule_manual_one_review_request) | **POST** /rescheduleManualOneReviewRequest | Reschedule Customer (Manual Schedule)
*ReviewSitesApi* | [**get_all_review_sites_by_user_name**](docs/ReviewSitesApi.md#get_all_review_sites_by_user_name) | **GET** /getAllReviewSitesByUserName | Get all review sites of an account
*ReviewSitesApi* | [**get_all_review_sites_bycompany_id**](docs/ReviewSitesApi.md#get_all_review_sites_bycompany_id) | **GET** /getAllReviewSitesBycompanyId | Get all review sites of a company
*ReviewsApi* | [**get_commentson_review**](docs/ReviewsApi.md#get_commentson_review) | **GET** /getCommentsonReview | Get review comments
*ReviewsApi* | [**get_reviews_by_company_id**](docs/ReviewsApi.md#get_reviews_by_company_id) | **GET** /getReviewsByCompanyID | Get X last reviews less than X days old of a company
*ReviewsApi* | [**get_reviews_by_company_id_and_rating**](docs/ReviewsApi.md#get_reviews_by_company_id_and_rating) | **GET** /getReviewsByCompanyIdAndRating | Get X last reviews that equal or over X stars of a company
*ReviewsApi* | [**get_reviews_by_company_id_and_review_site**](docs/ReviewsApi.md#get_reviews_by_company_id_and_review_site) | **GET** /getReviewsByCompanyIDAndReviewSite | Get X last reviews less than X days old of a review site of a company
*ReviewsApi* | [**get_reviews_by_company_id_rating_and_review_site**](docs/ReviewsApi.md#get_reviews_by_company_id_rating_and_review_site) | **GET** /getReviewsByCompanyIDRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of a company
*ReviewsApi* | [**get_reviews_by_user_name**](docs/ReviewsApi.md#get_reviews_by_user_name) | **GET** /getReviewsByUserName | Get X last reviews less than X days old of an account
*ReviewsApi* | [**get_reviews_by_user_name_and_rating**](docs/ReviewsApi.md#get_reviews_by_user_name_and_rating) | **GET** /getReviewsByUserNameAndRating | Get X last reviews that equal or over X stars of an account
*ReviewsApi* | [**get_reviews_by_user_name_and_review_site**](docs/ReviewsApi.md#get_reviews_by_user_name_and_review_site) | **GET** /getReviewsByUserNameAndReviewSite | Get X last reviews less than X days old of a review site of an account
*ReviewsApi* | [**get_reviews_by_user_name_rating_and_review_site**](docs/ReviewsApi.md#get_reviews_by_user_name_rating_and_review_site) | **GET** /getReviewsByUserNameRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of an account
*ReviewsApi* | [**post_comment_on_review**](docs/ReviewsApi.md#post_comment_on_review) | **POST** /postCommentOnReview | Comment on a Feedback / Review
*ReviewsStatsApi* | [**get_number_of_reviews_posted_in_last_days_by_company_id**](docs/ReviewsStatsApi.md#get_number_of_reviews_posted_in_last_days_by_company_id) | **GET** /getNumberOfReviewsPostedInLastDaysByCompanyId | Get total reviews received for each review site
*ReviewsStatsApi* | [**get_number_of_reviews_required_to_achieve5_star_by_company_id**](docs/ReviewsStatsApi.md#get_number_of_reviews_required_to_achieve5_star_by_company_id) | **GET** /getNumberOfReviewsRequiredToAchieve5StarByCompanyId | Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
*ReviewsStatsApi* | [**get_overall_rating_and_review_count_for_platform_reviews_by_company_id**](docs/ReviewsStatsApi.md#get_overall_rating_and_review_count_for_platform_reviews_by_company_id) | **GET** /getOverallRatingAndReviewCountForPlatformReviewsByCompanyId | Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
*ReviewsStatsApi* | [**get_overall_rating_for_each_review_site_by_company_id**](docs/ReviewsStatsApi.md#get_overall_rating_for_each_review_site_by_company_id) | **GET** /getOverallRatingForEachReviewSiteByCompanyId | Get overall rating for each review site
*ReviewsStatsApi* | [**get_overall_rating_of_company_by_company_id**](docs/ReviewsStatsApi.md#get_overall_rating_of_company_by_company_id) | **GET** /getOverallRatingOfCompanyByCompanyId | Get The Overall Rating of a Company / Location / Feedback Page 
*ReviewsStatsApi* | [**get_overall_reputation_change_of_all_review_sites_by_company_id**](docs/ReviewsStatsApi.md#get_overall_reputation_change_of_all_review_sites_by_company_id) | **GET** /getOverallReputationChangeOfAllReviewSitesByCompanyId | Get the Overall Reputation Increase / Decrease of ALL Review Sites 
*ReviewsStatsApi* | [**get_total_reviews_received_for_each_review_site_by_company_id**](docs/ReviewsStatsApi.md#get_total_reviews_received_for_each_review_site_by_company_id) | **GET** /getTotalReviewsReceivedForEachReviewSiteByCompanyId | Get total reviews received for each review site
*SentLogApi* | [**get_sent_log_by_company_id**](docs/SentLogApi.md#get_sent_log_by_company_id) | **GET** /getSentLogByCompanyId | Get company&#39;s sent log
*SentLogApi* | [**get_sent_log_by_customer_id**](docs/SentLogApi.md#get_sent_log_by_customer_id) | **GET** /getSentLogByCustomerId | Get a customerâ€™s sent log


## Documentation For Models

 - [Comment](docs/Comment.md)
 - [Customer](docs/Customer.md)
 - [CustomerWhoHaveNotResponded](docs/CustomerWhoHaveNotResponded.md)
 - [EmailSmsSentCount](docs/EmailSmsSentCount.md)
 - [EmailSmsSentLimit](docs/EmailSmsSentLimit.md)
 - [Error](docs/Error.md)
 - [OverallCompanyRating](docs/OverallCompanyRating.md)
 - [OverallRatingAndReviewCount](docs/OverallRatingAndReviewCount.md)
 - [Queue](docs/Queue.md)
 - [Review](docs/Review.md)
 - [ReviewSites](docs/ReviewSites.md)
 - [ReviewSitesRating](docs/ReviewSitesRating.md)
 - [ReviewSitesReputationChange](docs/ReviewSitesReputationChange.md)
 - [ReviewSitesReviewCount](docs/ReviewSitesReviewCount.md)
 - [SentLog](docs/SentLog.md)


## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: key
- **Location**: HTTP header


## Author

support@reputationcrm.com

