# coding: utf-8

"""
    Reputation CRM API

    Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/)   # noqa: E501

    OpenAPI spec version: 2.0.2
    Contact: support@reputationcrm.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class CustomerApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_customer_automatic(self, companyid, firstname, lastname, sendtype, **kwargs):  # noqa: E501
        """Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)  # noqa: E501

        This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH NO DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -> Notifications -> Email AND SMS Tabs   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_automatic(companyid, firstname, lastname, sendtype, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_customer_automatic_with_http_info(companyid, firstname, lastname, sendtype, **kwargs)  # noqa: E501
        else:
            (data) = self.create_customer_automatic_with_http_info(companyid, firstname, lastname, sendtype, **kwargs)  # noqa: E501
            return data

    def create_customer_automatic_with_http_info(self, companyid, firstname, lastname, sendtype, **kwargs):  # noqa: E501
        """Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)  # noqa: E501

        This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH NO DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -> Notifications -> Email AND SMS Tabs   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_automatic_with_http_info(companyid, firstname, lastname, sendtype, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['companyid', 'firstname', 'lastname', 'sendtype', 'email', 'mobile', 'address', 'zipcode', 'city', 'state', 'country', 'language', 'notes']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_customer_automatic" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'companyid' is set
        if ('companyid' not in params or
                params['companyid'] is None):
            raise ValueError("Missing the required parameter `companyid` when calling `create_customer_automatic`")  # noqa: E501
        # verify the required parameter 'firstname' is set
        if ('firstname' not in params or
                params['firstname'] is None):
            raise ValueError("Missing the required parameter `firstname` when calling `create_customer_automatic`")  # noqa: E501
        # verify the required parameter 'lastname' is set
        if ('lastname' not in params or
                params['lastname'] is None):
            raise ValueError("Missing the required parameter `lastname` when calling `create_customer_automatic`")  # noqa: E501
        # verify the required parameter 'sendtype' is set
        if ('sendtype' not in params or
                params['sendtype'] is None):
            raise ValueError("Missing the required parameter `sendtype` when calling `create_customer_automatic`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'companyid' in params:
            form_params.append(('companyid', params['companyid']))  # noqa: E501
        if 'firstname' in params:
            form_params.append(('firstname', params['firstname']))  # noqa: E501
        if 'lastname' in params:
            form_params.append(('lastname', params['lastname']))  # noqa: E501
        if 'email' in params:
            form_params.append(('email', params['email']))  # noqa: E501
        if 'mobile' in params:
            form_params.append(('mobile', params['mobile']))  # noqa: E501
        if 'address' in params:
            form_params.append(('address', params['address']))  # noqa: E501
        if 'zipcode' in params:
            form_params.append(('zipcode', params['zipcode']))  # noqa: E501
        if 'city' in params:
            form_params.append(('city', params['city']))  # noqa: E501
        if 'state' in params:
            form_params.append(('state', params['state']))  # noqa: E501
        if 'country' in params:
            form_params.append(('country', params['country']))  # noqa: E501
        if 'language' in params:
            form_params.append(('language', params['language']))  # noqa: E501
        if 'sendtype' in params:
            form_params.append(('sendtype', params['sendtype']))  # noqa: E501
        if 'notes' in params:
            form_params.append(('notes', params['notes']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/createCustomerAutomatic', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_customer_automatic_with_delay_review_request(self, companyid, firstname, lastname, sendtype, delay_before_first_review_request, **kwargs):  # noqa: E501
        """Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)  # noqa: E501

        This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH A DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -> Notifications -> Email AND SMS Tabs   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_automatic_with_delay_review_request(companyid, firstname, lastname, sendtype, delay_before_first_review_request, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str delay_before_first_review_request: Delay before sending the first Feedback / Review Request (Allowed values: \"immediately\", \"X minute\", \"X hour\", \"X day\", \"X week\", \"X month\", \"X year\")  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_customer_automatic_with_delay_review_request_with_http_info(companyid, firstname, lastname, sendtype, delay_before_first_review_request, **kwargs)  # noqa: E501
        else:
            (data) = self.create_customer_automatic_with_delay_review_request_with_http_info(companyid, firstname, lastname, sendtype, delay_before_first_review_request, **kwargs)  # noqa: E501
            return data

    def create_customer_automatic_with_delay_review_request_with_http_info(self, companyid, firstname, lastname, sendtype, delay_before_first_review_request, **kwargs):  # noqa: E501
        """Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)  # noqa: E501

        This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH A DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -> Notifications -> Email AND SMS Tabs   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_automatic_with_delay_review_request_with_http_info(companyid, firstname, lastname, sendtype, delay_before_first_review_request, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str delay_before_first_review_request: Delay before sending the first Feedback / Review Request (Allowed values: \"immediately\", \"X minute\", \"X hour\", \"X day\", \"X week\", \"X month\", \"X year\")  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['companyid', 'firstname', 'lastname', 'sendtype', 'delay_before_first_review_request', 'email', 'mobile', 'address', 'zipcode', 'city', 'state', 'country', 'language', 'notes']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_customer_automatic_with_delay_review_request" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'companyid' is set
        if ('companyid' not in params or
                params['companyid'] is None):
            raise ValueError("Missing the required parameter `companyid` when calling `create_customer_automatic_with_delay_review_request`")  # noqa: E501
        # verify the required parameter 'firstname' is set
        if ('firstname' not in params or
                params['firstname'] is None):
            raise ValueError("Missing the required parameter `firstname` when calling `create_customer_automatic_with_delay_review_request`")  # noqa: E501
        # verify the required parameter 'lastname' is set
        if ('lastname' not in params or
                params['lastname'] is None):
            raise ValueError("Missing the required parameter `lastname` when calling `create_customer_automatic_with_delay_review_request`")  # noqa: E501
        # verify the required parameter 'sendtype' is set
        if ('sendtype' not in params or
                params['sendtype'] is None):
            raise ValueError("Missing the required parameter `sendtype` when calling `create_customer_automatic_with_delay_review_request`")  # noqa: E501
        # verify the required parameter 'delay_before_first_review_request' is set
        if ('delay_before_first_review_request' not in params or
                params['delay_before_first_review_request'] is None):
            raise ValueError("Missing the required parameter `delay_before_first_review_request` when calling `create_customer_automatic_with_delay_review_request`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'companyid' in params:
            form_params.append(('companyid', params['companyid']))  # noqa: E501
        if 'firstname' in params:
            form_params.append(('firstname', params['firstname']))  # noqa: E501
        if 'lastname' in params:
            form_params.append(('lastname', params['lastname']))  # noqa: E501
        if 'email' in params:
            form_params.append(('email', params['email']))  # noqa: E501
        if 'mobile' in params:
            form_params.append(('mobile', params['mobile']))  # noqa: E501
        if 'address' in params:
            form_params.append(('address', params['address']))  # noqa: E501
        if 'zipcode' in params:
            form_params.append(('zipcode', params['zipcode']))  # noqa: E501
        if 'city' in params:
            form_params.append(('city', params['city']))  # noqa: E501
        if 'state' in params:
            form_params.append(('state', params['state']))  # noqa: E501
        if 'country' in params:
            form_params.append(('country', params['country']))  # noqa: E501
        if 'language' in params:
            form_params.append(('language', params['language']))  # noqa: E501
        if 'sendtype' in params:
            form_params.append(('sendtype', params['sendtype']))  # noqa: E501
        if 'notes' in params:
            form_params.append(('notes', params['notes']))  # noqa: E501
        if 'delay_before_first_review_request' in params:
            form_params.append(('delayBeforeFirstReviewRequest', params['delay_before_first_review_request']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/createCustomerAutomaticWithDelayReviewRequest', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_customer_immediate_first_review_request(self, companyid, firstname, lastname, sendtype, **kwargs):  # noqa: E501
        """Create a Customer AND Feedback / Review Requests  # noqa: E501

        This API call creates a Customer in Reputation Builder AND Feedback / Review Request #1 (Email #1 AND/OR SMS #1 ONLY). Feedback / Review Request(s) are then sent immediately   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_immediate_first_review_request(companyid, firstname, lastname, sendtype, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_customer_immediate_first_review_request_with_http_info(companyid, firstname, lastname, sendtype, **kwargs)  # noqa: E501
        else:
            (data) = self.create_customer_immediate_first_review_request_with_http_info(companyid, firstname, lastname, sendtype, **kwargs)  # noqa: E501
            return data

    def create_customer_immediate_first_review_request_with_http_info(self, companyid, firstname, lastname, sendtype, **kwargs):  # noqa: E501
        """Create a Customer AND Feedback / Review Requests  # noqa: E501

        This API call creates a Customer in Reputation Builder AND Feedback / Review Request #1 (Email #1 AND/OR SMS #1 ONLY). Feedback / Review Request(s) are then sent immediately   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_immediate_first_review_request_with_http_info(companyid, firstname, lastname, sendtype, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['companyid', 'firstname', 'lastname', 'sendtype', 'email', 'mobile', 'address', 'zipcode', 'city', 'state', 'country', 'language', 'notes']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_customer_immediate_first_review_request" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'companyid' is set
        if ('companyid' not in params or
                params['companyid'] is None):
            raise ValueError("Missing the required parameter `companyid` when calling `create_customer_immediate_first_review_request`")  # noqa: E501
        # verify the required parameter 'firstname' is set
        if ('firstname' not in params or
                params['firstname'] is None):
            raise ValueError("Missing the required parameter `firstname` when calling `create_customer_immediate_first_review_request`")  # noqa: E501
        # verify the required parameter 'lastname' is set
        if ('lastname' not in params or
                params['lastname'] is None):
            raise ValueError("Missing the required parameter `lastname` when calling `create_customer_immediate_first_review_request`")  # noqa: E501
        # verify the required parameter 'sendtype' is set
        if ('sendtype' not in params or
                params['sendtype'] is None):
            raise ValueError("Missing the required parameter `sendtype` when calling `create_customer_immediate_first_review_request`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'companyid' in params:
            form_params.append(('companyid', params['companyid']))  # noqa: E501
        if 'firstname' in params:
            form_params.append(('firstname', params['firstname']))  # noqa: E501
        if 'lastname' in params:
            form_params.append(('lastname', params['lastname']))  # noqa: E501
        if 'email' in params:
            form_params.append(('email', params['email']))  # noqa: E501
        if 'mobile' in params:
            form_params.append(('mobile', params['mobile']))  # noqa: E501
        if 'address' in params:
            form_params.append(('address', params['address']))  # noqa: E501
        if 'zipcode' in params:
            form_params.append(('zipcode', params['zipcode']))  # noqa: E501
        if 'city' in params:
            form_params.append(('city', params['city']))  # noqa: E501
        if 'state' in params:
            form_params.append(('state', params['state']))  # noqa: E501
        if 'country' in params:
            form_params.append(('country', params['country']))  # noqa: E501
        if 'language' in params:
            form_params.append(('language', params['language']))  # noqa: E501
        if 'sendtype' in params:
            form_params.append(('sendtype', params['sendtype']))  # noqa: E501
        if 'notes' in params:
            form_params.append(('notes', params['notes']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/createCustomerImmediateFirstReviewRequest', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_customer_manual_schedule_one_review_request(self, companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, **kwargs):  # noqa: E501
        """Create a Customer AND a one Feedback / Review Request (Manual Scheduling)  # noqa: E501

        This API call creates a Customer in Reputation Builder AND one Feedback / Review Request. You decide which Feedback / Review Request # to send, the sending method (Email or SMS) and you have full control of the sending date and time   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_manual_schedule_one_review_request(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str emailnumber: Set which Email Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\")  (required)
        :param str smsnumber: Set which SMS Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\")  (required)
        :param str scheduledate: Schedule date (yyyy/mm/dd)  (required)
        :param str scheduletime: Schedule time (HH:MM 24 hours format)  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_customer_manual_schedule_one_review_request_with_http_info(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, **kwargs)  # noqa: E501
        else:
            (data) = self.create_customer_manual_schedule_one_review_request_with_http_info(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, **kwargs)  # noqa: E501
            return data

    def create_customer_manual_schedule_one_review_request_with_http_info(self, companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, **kwargs):  # noqa: E501
        """Create a Customer AND a one Feedback / Review Request (Manual Scheduling)  # noqa: E501

        This API call creates a Customer in Reputation Builder AND one Feedback / Review Request. You decide which Feedback / Review Request # to send, the sending method (Email or SMS) and you have full control of the sending date and time   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_customer_manual_schedule_one_review_request_with_http_info(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str sendtype: Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"  (required)
        :param str emailnumber: Set which Email Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\")  (required)
        :param str smsnumber: Set which SMS Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\")  (required)
        :param str scheduledate: Schedule date (yyyy/mm/dd)  (required)
        :param str scheduletime: Schedule time (HH:MM 24 hours format)  (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
        :param str language: Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
        :param str notes: Additional Customer Notes
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['companyid', 'firstname', 'lastname', 'sendtype', 'emailnumber', 'smsnumber', 'scheduledate', 'scheduletime', 'email', 'mobile', 'address', 'zipcode', 'city', 'state', 'country', 'language', 'notes']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_customer_manual_schedule_one_review_request" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'companyid' is set
        if ('companyid' not in params or
                params['companyid'] is None):
            raise ValueError("Missing the required parameter `companyid` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501
        # verify the required parameter 'firstname' is set
        if ('firstname' not in params or
                params['firstname'] is None):
            raise ValueError("Missing the required parameter `firstname` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501
        # verify the required parameter 'lastname' is set
        if ('lastname' not in params or
                params['lastname'] is None):
            raise ValueError("Missing the required parameter `lastname` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501
        # verify the required parameter 'sendtype' is set
        if ('sendtype' not in params or
                params['sendtype'] is None):
            raise ValueError("Missing the required parameter `sendtype` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501
        # verify the required parameter 'emailnumber' is set
        if ('emailnumber' not in params or
                params['emailnumber'] is None):
            raise ValueError("Missing the required parameter `emailnumber` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501
        # verify the required parameter 'smsnumber' is set
        if ('smsnumber' not in params or
                params['smsnumber'] is None):
            raise ValueError("Missing the required parameter `smsnumber` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501
        # verify the required parameter 'scheduledate' is set
        if ('scheduledate' not in params or
                params['scheduledate'] is None):
            raise ValueError("Missing the required parameter `scheduledate` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501
        # verify the required parameter 'scheduletime' is set
        if ('scheduletime' not in params or
                params['scheduletime'] is None):
            raise ValueError("Missing the required parameter `scheduletime` when calling `create_customer_manual_schedule_one_review_request`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'companyid' in params:
            form_params.append(('companyid', params['companyid']))  # noqa: E501
        if 'firstname' in params:
            form_params.append(('firstname', params['firstname']))  # noqa: E501
        if 'lastname' in params:
            form_params.append(('lastname', params['lastname']))  # noqa: E501
        if 'email' in params:
            form_params.append(('email', params['email']))  # noqa: E501
        if 'mobile' in params:
            form_params.append(('mobile', params['mobile']))  # noqa: E501
        if 'address' in params:
            form_params.append(('address', params['address']))  # noqa: E501
        if 'zipcode' in params:
            form_params.append(('zipcode', params['zipcode']))  # noqa: E501
        if 'city' in params:
            form_params.append(('city', params['city']))  # noqa: E501
        if 'state' in params:
            form_params.append(('state', params['state']))  # noqa: E501
        if 'country' in params:
            form_params.append(('country', params['country']))  # noqa: E501
        if 'language' in params:
            form_params.append(('language', params['language']))  # noqa: E501
        if 'sendtype' in params:
            form_params.append(('sendtype', params['sendtype']))  # noqa: E501
        if 'notes' in params:
            form_params.append(('notes', params['notes']))  # noqa: E501
        if 'emailnumber' in params:
            form_params.append(('emailnumber', params['emailnumber']))  # noqa: E501
        if 'smsnumber' in params:
            form_params.append(('smsnumber', params['smsnumber']))  # noqa: E501
        if 'scheduledate' in params:
            form_params.append(('scheduledate', params['scheduledate']))  # noqa: E501
        if 'scheduletime' in params:
            form_params.append(('scheduletime', params['scheduletime']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/createCustomerManualScheduleOneReviewRequest', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_customer(self, customerid, **kwargs):  # noqa: E501
        """Delete ONE Customer record  # noqa: E501

        This API call deletes an existing Customer from Reputation Builder. It will also delete all Email / SMS Requests still in the Queue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_customer(customerid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str customerid: Customer ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_customer_with_http_info(customerid, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_customer_with_http_info(customerid, **kwargs)  # noqa: E501
            return data

    def delete_customer_with_http_info(self, customerid, **kwargs):  # noqa: E501
        """Delete ONE Customer record  # noqa: E501

        This API call deletes an existing Customer from Reputation Builder. It will also delete all Email / SMS Requests still in the Queue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_customer_with_http_info(customerid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str customerid: Customer ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['customerid']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_customer" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'customerid' is set
        if ('customerid' not in params or
                params['customerid'] is None):
            raise ValueError("Missing the required parameter `customerid` when calling `delete_customer`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'customerid' in params:
            form_params.append(('customerid', params['customerid']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/deleteCustomer', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_customers_bycompany_id(self, companyid, **kwargs):  # noqa: E501
        """Get Information on ALL Customers of a Company / Location / Feedback Page  # noqa: E501

        This API call returns information from Reputation Builder on ALL existing Customers of a Company / Location / Feedback Page  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_all_customers_bycompany_id(companyid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :return: list[Customer]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_all_customers_bycompany_id_with_http_info(companyid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_all_customers_bycompany_id_with_http_info(companyid, **kwargs)  # noqa: E501
            return data

    def get_all_customers_bycompany_id_with_http_info(self, companyid, **kwargs):  # noqa: E501
        """Get Information on ALL Customers of a Company / Location / Feedback Page  # noqa: E501

        This API call returns information from Reputation Builder on ALL existing Customers of a Company / Location / Feedback Page  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_all_customers_bycompany_id_with_http_info(companyid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :return: list[Customer]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['companyid']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_customers_bycompany_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'companyid' is set
        if ('companyid' not in params or
                params['companyid'] is None):
            raise ValueError("Missing the required parameter `companyid` when calling `get_all_customers_bycompany_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'companyid' in params:
            query_params.append(('companyid', params['companyid']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/getAllCustomersBycompanyId', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Customer]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_customers_who_have_not_yet_submitted_review(self, companyid, **kwargs):  # noqa: E501
        """Get a list of Customers who have not yet submitted their Review / Feedback  # noqa: E501

        This API call returns the list of Customers of a Company / Location / Feedback Page who have not yet responded to Feedback / Review Requests  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_customers_who_have_not_yet_submitted_review(companyid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :return: list[CustomerWhoHaveNotResponded]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_customers_who_have_not_yet_submitted_review_with_http_info(companyid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_customers_who_have_not_yet_submitted_review_with_http_info(companyid, **kwargs)  # noqa: E501
            return data

    def get_customers_who_have_not_yet_submitted_review_with_http_info(self, companyid, **kwargs):  # noqa: E501
        """Get a list of Customers who have not yet submitted their Review / Feedback  # noqa: E501

        This API call returns the list of Customers of a Company / Location / Feedback Page who have not yet responded to Feedback / Review Requests  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_customers_who_have_not_yet_submitted_review_with_http_info(companyid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str companyid: Company ID (required)
        :return: list[CustomerWhoHaveNotResponded]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['companyid']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_customers_who_have_not_yet_submitted_review" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'companyid' is set
        if ('companyid' not in params or
                params['companyid'] is None):
            raise ValueError("Missing the required parameter `companyid` when calling `get_customers_who_have_not_yet_submitted_review`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'companyid' in params:
            query_params.append(('companyid', params['companyid']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/getCustomersWhoHaveNotYetSubmittedReview', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CustomerWhoHaveNotResponded]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_single_customer(self, customerid, **kwargs):  # noqa: E501
        """Get Information of ONE Customer  # noqa: E501

        This API call returns information from Reputation Builder on ONE existing Customer  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_single_customer(customerid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str customerid: Customer ID (required)
        :return: list[Customer]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_single_customer_with_http_info(customerid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_single_customer_with_http_info(customerid, **kwargs)  # noqa: E501
            return data

    def get_single_customer_with_http_info(self, customerid, **kwargs):  # noqa: E501
        """Get Information of ONE Customer  # noqa: E501

        This API call returns information from Reputation Builder on ONE existing Customer  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_single_customer_with_http_info(customerid, async=True)
        >>> result = thread.get()

        :param async bool
        :param str customerid: Customer ID (required)
        :return: list[Customer]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['customerid']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_single_customer" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'customerid' is set
        if ('customerid' not in params or
                params['customerid'] is None):
            raise ValueError("Missing the required parameter `customerid` when calling `get_single_customer`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'customerid' in params:
            query_params.append(('customerid', params['customerid']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/getSingleCustomer', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Customer]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_customer(self, customerid, firstname, lastname, notes, **kwargs):  # noqa: E501
        """Update the record of ONE Customer  # noqa: E501

        This API call updates information from Reputation Builder on ONE existing Customer  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_customer(customerid, firstname, lastname, notes, async=True)
        >>> result = thread.get()

        :param async bool
        :param str customerid: Customer ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str notes: Additional Customer Notes (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country
        :param str language: Customer Language
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.update_customer_with_http_info(customerid, firstname, lastname, notes, **kwargs)  # noqa: E501
        else:
            (data) = self.update_customer_with_http_info(customerid, firstname, lastname, notes, **kwargs)  # noqa: E501
            return data

    def update_customer_with_http_info(self, customerid, firstname, lastname, notes, **kwargs):  # noqa: E501
        """Update the record of ONE Customer  # noqa: E501

        This API call updates information from Reputation Builder on ONE existing Customer  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_customer_with_http_info(customerid, firstname, lastname, notes, async=True)
        >>> result = thread.get()

        :param async bool
        :param str customerid: Customer ID (required)
        :param str firstname: Customer First Name (required)
        :param str lastname: Customer Last Name (required)
        :param str notes: Additional Customer Notes (required)
        :param str email: Customer Email
        :param str mobile: Customer Mobile Phone
        :param str address: Customer Postal Address
        :param str zipcode: Customer Zipcode
        :param str city: Customer City
        :param str state: Customer State / Province / Region
        :param str country: Customer Country
        :param str language: Customer Language
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['customerid', 'firstname', 'lastname', 'notes', 'email', 'mobile', 'address', 'zipcode', 'city', 'state', 'country', 'language']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_customer" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'customerid' is set
        if ('customerid' not in params or
                params['customerid'] is None):
            raise ValueError("Missing the required parameter `customerid` when calling `update_customer`")  # noqa: E501
        # verify the required parameter 'firstname' is set
        if ('firstname' not in params or
                params['firstname'] is None):
            raise ValueError("Missing the required parameter `firstname` when calling `update_customer`")  # noqa: E501
        # verify the required parameter 'lastname' is set
        if ('lastname' not in params or
                params['lastname'] is None):
            raise ValueError("Missing the required parameter `lastname` when calling `update_customer`")  # noqa: E501
        # verify the required parameter 'notes' is set
        if ('notes' not in params or
                params['notes'] is None):
            raise ValueError("Missing the required parameter `notes` when calling `update_customer`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'customerid' in params:
            form_params.append(('customerid', params['customerid']))  # noqa: E501
        if 'firstname' in params:
            form_params.append(('firstname', params['firstname']))  # noqa: E501
        if 'lastname' in params:
            form_params.append(('lastname', params['lastname']))  # noqa: E501
        if 'email' in params:
            form_params.append(('email', params['email']))  # noqa: E501
        if 'mobile' in params:
            form_params.append(('mobile', params['mobile']))  # noqa: E501
        if 'address' in params:
            form_params.append(('address', params['address']))  # noqa: E501
        if 'zipcode' in params:
            form_params.append(('zipcode', params['zipcode']))  # noqa: E501
        if 'city' in params:
            form_params.append(('city', params['city']))  # noqa: E501
        if 'state' in params:
            form_params.append(('state', params['state']))  # noqa: E501
        if 'country' in params:
            form_params.append(('country', params['country']))  # noqa: E501
        if 'language' in params:
            form_params.append(('language', params['language']))  # noqa: E501
        if 'notes' in params:
            form_params.append(('notes', params['notes']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/updateCustomer', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
